/************************************************************************************/
/*  Program name CAPGLEXT_VALUES_TL.sql                                             */
/*  Creater:  NIP Karen (PCCW - UniHub)                                             */
/*************   History   *************************                                */
/* 12 JAN, 2005   NIP Karen         First created                                   */
/************************************************************************************/
ALTER SESSION SET NLS_DATE_FORMAT='YYYYMMDD HH24:MI:SS';
SET SERVEROUTPUT ON SIZE 1000000;

DECLARE
	lv_Prog_ID		VARCHAR2(100)	:=	'CAPGLEXT_VALUES_TL';

	lv_Scc_Count	NUMBER	:=	0;
	lv_Err_Count	NUMBER	:=	0;
	lv_Err_Msg		VARCHAR2(500)	:=	'No Error';

	lv_FileName		VARCHAR2(100)	:=	'CAPGL_VALUES_TL.dat';
	lv_PathName		VARCHAR2(100)	:=	'/tmp';
	lv_UTL_File		UTL_FILE.File_Type;

	lv_NGO_Name		VARCHAR2(100);
	lv_NGO_Count	NUMBER;

	CURSOR Cur_F(p_NGO VARCHAR2) IS
	SELECT 
		FFVT.*
	FROM   
		FND_FLEX_VALUES_TL		FFVT
	WHERE	FLEX_VALUE_ID	IN	(
		SELECT
			FFV.FLEX_VALUE_ID
		FROM
			FND_FLEX_VALUES FFV
		,	FND_FLEX_VALUE_SETS FFVS
		WHERE	UPPER(SUBSTR(FFVS.FLEX_VALUE_SET_NAME,1,4))	=	UPPER(p_NGO) 
		AND		FFVS.FLEX_VALUE_SET_ID	=	FFV.FLEX_VALUE_SET_ID);

BEGIN
	lv_NGO_Name		:=	UPPER('&NGO_Code');

	SELECT	COUNT('A')
	INTO	lv_NGO_Count
	FROM	HR_ALL_ORGANIZATION_UNITS
	WHERE	SUBSTR(Name,4,4)	=	lv_NGO_Name;

	IF	lv_NGO_Count	>=	1	THEN
		lv_UTL_File		:=	UTL_FILE.FOpen(lv_PathName, lv_FileName, 'w');
		FOR C1 IN Cur_F(lv_NGO_Name) LOOP
			UTL_FILE.PUT_LINE(
				lv_UTL_File,
				C1.FLEX_VALUE_ID||CHR(9)||
				C1.LANGUAGE||CHR(9)||
				C1.LAST_UPDATE_DATE||CHR(9)||
					C1.LAST_UPDATED_BY||CHR(9)||
				C1.CREATION_DATE||CHR(9)||
					C1.CREATED_BY||CHR(9)||
				C1.LAST_UPDATE_LOGIN||CHR(9)||
				C1.DESCRIPTION||CHR(9)||
				C1.SOURCE_LANG||CHR(9)||
				C1.FLEX_VALUE_MEANING||CHR(9)||
				CAPBREXT_COMMON.GetUser(C1.LAST_UPDATED_BY)||CHR(9)||
				CAPBREXT_COMMON.GetUser(C1.CREATED_BY)
			);

			lv_Scc_Count	:=	lv_Scc_Count	+	1;
		END LOOP;
		UTL_FILE.FClose(lv_UTL_File);
	ELSE
		lv_Err_Count	:=	lv_Err_Count + 1;
		lv_Err_Msg		:=	lv_NGO_Name||': No segment values description for this NGO service unit segment';
	END IF;

	INSERT INTO CAPCNV_LOG(
		PROG_ID,
		PROCESS_DATE,
		RECORD_PROCESSED,
		RECORD_REJECTED,
		RECORD_EXTRACTED,
		ERR_MSG
	) VALUES (
		lv_Prog_ID,
		SYSDATE,
		lv_Scc_Count,
		lv_Err_Count,
		lv_Scc_Count-lv_Err_Count,
		lv_Err_Msg
	);

	COMMIT;
END;
/
